<!DOCTYPE html>
<html>

<head>
    <title>Task 66 - Add District</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
    <div class="container-fluid pt-5">
        <div class="row form-group">
            <div class="col-1"></div>
            <div class="col-10 form-group jumbotron" style="border-style:double">
                <h2 class="text-center">Thêm Quận, Huyện</h2>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="district" class="border-0 bg-transparent"><b>Tên</b></label>
                    </div>
                    <div class="col-8">
                        <input id="inp-district" type="text" name="district" placeholder="Add District" class="form-control border-primary">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="code" class="border-0 bg-transparent"><b>Quận, Huyện</b></label>
                    </div>
                    <div class="col-sm-8">
                        <select id="select-district" class="form-control border-primary">
                            <option value="none">--Chọn--</option>
                            <option value="quan">Quận</option>
                            <option value="huyen">Huyện</option>
                        </select>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="code" class="border-0 bg-transparent"><b>Tên Tỉnh/TP</b><span
                                style="color:red">*</span></label>
                    </div>
                    <div class="col-sm-8">
                        <select id="select-province" class="form-control border-primary">
                            <option value="none">--Chọn--</option>
                        </select>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label for="id" class="border-0 bg-transparent"><b>Id Quận, Huyện</b></label>
                    </div>
                    <div class="col-sm-8">
                        <select id="select-id" class="form-control border-primary">
                            <option value="none">--Chọn (Trường hợp Edit và Delete)--</option>
                        </select>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-6"></div>
                    <div class="col-6 text-right">
                        <button class="btn btn-primary" id="add-district">Add</button>
                        <button class="btn btn-success" id="edit-district">Edit</button>
                        <button class="btn btn-danger" id="delete-district">Delete</button>
                        <button class="btn btn-light" id="cancel-district">Cancel</button>
                    </div>
                </div>
                <div class="col-1"></div>
            </div>
        </div>

</body>
<script>
    $(document).ready(function() {
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        onPageLoading();
        var gProvince = [];
        var gDistrict = [];
        var gDistrictId = "";
        var gProvinceId = "";
        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
        // gán sự kiện change cho select province
        $('#select-province').on('change', function() {
            onBtnChangeIdSelectProvince();
        });
        // gán sự kiện change cho select Id Quận, Huyện
        $('#select-id').on('change', function() {
            onBtnChangeIdSelectDistrict();
        });
        // gán sự kiện add cho nút Add District
        $('#add-district').on('click', function() {
            onBtnAddDistrict();
        });
        // gán sự kiện add cho nút Edit District
        $('#edit-district').on('click', function() {
            onBtnEditDistrict();
        });
        // gán sự kiện add cho nút Edit District
        $('#delete-district').on('click', function() {
            onBtnDeleteDistrict();
        });

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        function onPageLoading() {
            "use strict";
            getAllProvince();
        }

        function getAllProvince() {
            $.ajax({
                url: "http://localhost:8080/province",
                type: "GET",
                dataType: 'json',
                async: false,
                success: function(responseObject) {
                    gProvince = responseObject;
                    console.log(gProvince);
                    loadDataIntoSelect(gProvince);
                },
                error: function(error) {
                    console.log(error.responseText);
                }
            });
        }

        function loadDataIntoSelect(paramObject) {
            for (var bI = 0; bI < paramObject.length; bI++) {
                $('#select-province').append($('<option>', {
                    value: paramObject[bI].id,
                    text: paramObject[bI].name
                }));
            }
        }


        function loadDataIntoSelectIdDistrict(paramObject) {
            for (var bI = 0; bI < paramObject.length; bI++) {
                $('#select-id').append($('<option>', {
                    value: paramObject[bI].id,
                    text: paramObject[bI].id
                }));
            }
        }

        function onBtnAddDistrict() {
            "use strict";
            var vDistrictObject = {
                name: "",
                prefix: "",
            }
            vDistrictObject.name = $("#inp-district").val().trim();
            vDistrictObject.prefix = $("#select-district option:selected").text();

            //gProvinceId = $("#select-province").val();

            console.log(gProvinceId)
            console.log(vDistrictObject)
            $.ajax({
                async: false,
                url: "http://localhost:8080/district-create/" + gProvinceId ,
                type: "POST",
                data: JSON.stringify(vDistrictObject),
                contentType: 'application/json;charset=UTF-8',
                success: function(res) {
                    console.log(res);
                    gDistrict.push(res);
                    alert("Thêm district thành công!");
                    loadDataIntoSelectIdDistrict(gDistrict);
                    $("#inp-district").val("");
                    $("#select-district").val("none");
                    $("#select-province").val("none");
                    $("select-id").val("none");

                },
                error: function(error) {
                    alert(error.responseText);
                }
            });
        }

        function onBtnEditDistrict() {
            "use strict";
            console.log("nút edit được nhấn");
            var vDistrictObject = {
                name: "",
                prefix: "",
            }
            vDistrictObject.name = $("#inp-district").val().trim();
            vDistrictObject.prefix = $("#select-district option:selected").text();
            console.log(vDistrictObject);
            console.log("mã quận, huyện" + gDistrictId);
            $.ajax({
                async: false,
                url: "http://localhost:8080/district-update/" + gDistrictId,
                type: "PUT",
                data: JSON.stringify(vDistrictObject),
                contentType: 'application/json;charset=UTF-8',
                success: function(res) {
                    console.log(res);
                    gDistrict.push(res);
                    alert("Update District thành công!");
                    loadDataIntoSelectIdDistrict(gDistrict);
                    $("#inp-district").val("");
                    $("#select-district").val("none");
                    $("#select-province").val("none");
                    $("select-id").val("none");
                },
                error: function(error) {
                    alert(error.responseText);
                }
            });
        }
        ///asdasdasdsadsa
        // Hàm xử lý khi change select id province
        function onBtnChangeIdSelectProvince() {
            "use strict";
            gProvinceId = $("#select-province").val(); // lấy ra provinceId từ select đc chọn
            console.log("Province được chọn có Id: " + gProvinceId);
            if (gProvinceId != "none") {
                //Gọi APi theo provinceID
                $.ajax({
                    url: "http://localhost:8080/provinces/" + gProvinceId,
                    type: "GET",
                    dataType: 'json',
                    async: false,
                    success: function(res) {
                        console.log(res);
                        gDistrict = res.district;
                        console.log(gDistrict);
                        loadDataIntoSelectIdDistrict(gDistrict);
                    },
                    error: function(error) {
                        console.log(error.responseText);
                    }
                });
            }
        }

        function onBtnChangeIdSelectDistrict() {
            "use strict";
            gDistrictId = $("#select-id").val(); // lấy ra provinceId từ select đc chọn
            console.log("District được chọn có Id: " + gDistrictId);
            if (gDistrictId != "none") {
                //Gọi APi theo provinceID
                $.ajax({
                    url: "http://localhost:8080/districts/" + gDistrictId,
                    type: "GET",
                    dataType: 'json',
                    async: false,
                    success: function(res) {
                        console.log(res);
                        $("#inp-district").val(res.name);
                        $("#select-district option:selected").text(res.prefix);

                    },
                    error: function(error) {
                        console.log(error.responseText);
                    }
                });
            }
        }

        function onBtnDeleteDistrict() {
            "use strict";
            console.log(gDistrictId);
            $.ajax({
                async: false,
                url: "http://localhost:8080/district-delete/" + gDistrictId,
                type: "DELETE",
                data: 'json',
                success: function(res) {
                    alert("Xóa District thành công!");
                    $("#inp-district").val("");
                    $("#select-district").val("none");
                    $("#select-province").val("none");
                    $("select-id").val("none");
                },
                error: function(error) {
                    alert(error.responseText);
                }
            })
        }
        
    });
</script>

</html>